/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

#ifndef YY_MPD_PARSERS_MPD_PARSER_H_INCLUDED
# define YY_MPD_PARSERS_MPD_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef MPD_DEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define MPD_DEBUG 1
#  else
#   define MPD_DEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define MPD_DEBUG 1
# endif /* ! defined YYDEBUG */
#endif  /* ! defined MPD_DEBUG */
#if MPD_DEBUG
extern int mpd_debug;
#endif
/* "%code requires" blocks.  */
#line 201 "parsers/mpd_parser.y"

struct mpd_result_part {
  char str[8192];
  int offset;
};

struct mpd_result {
  struct mpd_result_part where_part;
  struct mpd_result_part order_part;
  struct mpd_result_part group_part;
  char tagtype_buf[64];
  char position_buf[64];

  // Pointers to the strings in mpd_result_part
  const char *where;
  const char *order;
  const char *group;

  const char *tagtype;
  const char *position;

  // Set to 0 if not found
  int offset;
  int limit;

  int err;
  char errmsg[128];
};

enum mpd_type {
  MPD_TYPE_INT,
  MPD_TYPE_STRING,
  MPD_TYPE_SPECIAL,
};

struct mpd_tag_map {
  const char *name;
  const char *dbcol;
  enum mpd_type type;
  int dbmfi_offset;
};

char *mpd_parser_quoted(const char *str);
struct mpd_tag_map *mpd_parser_tag_from_dbcol(const char *dbcol);
void mpd_parser_enum_tagtypes(void (*func)(struct mpd_tag_map *, void *), void *arg);

#line 104 "parsers/mpd_parser.h"

/* Token kinds.  */
#ifndef MPD_TOKENTYPE
# define MPD_TOKENTYPE
  enum mpd_tokentype
  {
    MPD_EMPTY = -2,
    MPD_EOF = 0,                   /* "end of file"  */
    MPD_error = 256,               /* error  */
    MPD_UNDEF = 257,               /* "invalid token"  */
    MPD_T_CMDSEARCH = 258,         /* MPD_T_CMDSEARCH  */
    MPD_T_CMDSEARCHADD = 259,      /* MPD_T_CMDSEARCHADD  */
    MPD_T_CMDFIND = 260,           /* MPD_T_CMDFIND  */
    MPD_T_CMDFINDADD = 261,        /* MPD_T_CMDFINDADD  */
    MPD_T_CMDCOUNT = 262,          /* MPD_T_CMDCOUNT  */
    MPD_T_CMDSEARCHCOUNT = 263,    /* MPD_T_CMDSEARCHCOUNT  */
    MPD_T_CMDPLAYLISTFIND = 264,   /* MPD_T_CMDPLAYLISTFIND  */
    MPD_T_CMDPLAYLISTSEARCH = 265, /* MPD_T_CMDPLAYLISTSEARCH  */
    MPD_T_CMDLIST = 266,           /* MPD_T_CMDLIST  */
    MPD_T_SORT = 267,              /* MPD_T_SORT  */
    MPD_T_WINDOW = 268,            /* MPD_T_WINDOW  */
    MPD_T_POSITION = 269,          /* MPD_T_POSITION  */
    MPD_T_GROUP = 270,             /* MPD_T_GROUP  */
    MPD_T_STRING = 271,            /* MPD_T_STRING  */
    MPD_T_NUM = 272,               /* MPD_T_NUM  */
    MPD_T_TIME = 273,              /* MPD_T_TIME  */
    MPD_T_STRTAG = 274,            /* MPD_T_STRTAG  */
    MPD_T_INTTAG = 275,            /* MPD_T_INTTAG  */
    MPD_T_SINCETAG = 276,          /* MPD_T_SINCETAG  */
    MPD_T_BASETAG = 277,           /* MPD_T_BASETAG  */
    MPD_T_ANYTAG = 278,            /* MPD_T_ANYTAG  */
    MPD_T_AUDIOFORMATTAG = 279,    /* MPD_T_AUDIOFORMATTAG  */
    MPD_T_PARENS = 280,            /* MPD_T_PARENS  */
    MPD_T_OR = 281,                /* MPD_T_OR  */
    MPD_T_AND = 282,               /* MPD_T_AND  */
    MPD_T_NOT = 283,               /* MPD_T_NOT  */
    MPD_T_CONTAINS = 284,          /* MPD_T_CONTAINS  */
    MPD_T_STARTSWITH = 285,        /* MPD_T_STARTSWITH  */
    MPD_T_ENDSWITH = 286,          /* MPD_T_ENDSWITH  */
    MPD_T_EQUAL = 287,             /* MPD_T_EQUAL  */
    MPD_T_NOTEQUAL = 288,          /* MPD_T_NOTEQUAL  */
    MPD_T_LESS = 289,              /* MPD_T_LESS  */
    MPD_T_LESSEQUAL = 290,         /* MPD_T_LESSEQUAL  */
    MPD_T_GREATER = 291,           /* MPD_T_GREATER  */
    MPD_T_GREATEREQUAL = 292       /* MPD_T_GREATEREQUAL  */
  };
  typedef enum mpd_tokentype mpd_token_kind_t;
#endif

/* Value type.  */
#if ! defined MPD_STYPE && ! defined MPD_STYPE_IS_DECLARED
union MPD_STYPE
{
#line 627 "parsers/mpd_parser.y"

  unsigned int ival;
  char *str;
  struct ast *ast;

#line 164 "parsers/mpd_parser.h"

};
typedef union MPD_STYPE MPD_STYPE;
# define MPD_STYPE_IS_TRIVIAL 1
# define MPD_STYPE_IS_DECLARED 1
#endif




int mpd_parse (struct mpd_result *result, void *scanner);

/* "%code provides" blocks.  */
#line 42 "parsers/mpd_parser.y"

/* Convenience functions for caller to use instead of interfacing with lexer and
   parser directly */
int mpd_lex_cb(char *input, void (*cb)(int, const char *));
int mpd_lex_parse(struct mpd_result *result, const char *input);

#line 185 "parsers/mpd_parser.h"

#endif /* !YY_MPD_PARSERS_MPD_PARSER_H_INCLUDED  */
