/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

#ifndef YY_SMARTPL_PARSERS_SMARTPL_PARSER_H_INCLUDED
# define YY_SMARTPL_PARSERS_SMARTPL_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef SMARTPL_DEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define SMARTPL_DEBUG 1
#  else
#   define SMARTPL_DEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define SMARTPL_DEBUG 1
# endif /* ! defined YYDEBUG */
#endif  /* ! defined SMARTPL_DEBUG */
#if SMARTPL_DEBUG
extern int smartpl_debug;
#endif
/* "%code requires" blocks.  */
#line 201 "parsers/smartpl_parser.y"

struct result_part {
  char str[8192];
  int offset;
};

struct smartpl_result {
  struct result_part where_part;
  struct result_part order_part;
  struct result_part having_part;
  char title[128];
  const char *where; // Points to where_part.str
  const char *order; // Points to order_part.str
  const char *having; // Points to having_part.str
  int limit;
  int err;
  char errmsg[128];
};

#line 77 "parsers/smartpl_parser.h"

/* Token kinds.  */
#ifndef SMARTPL_TOKENTYPE
# define SMARTPL_TOKENTYPE
  enum smartpl_tokentype
  {
    SMARTPL_EMPTY = -2,
    SMARTPL_EOF = 0,               /* "end of file"  */
    SMARTPL_error = 256,           /* error  */
    SMARTPL_UNDEF = 257,           /* "invalid token"  */
    SMARTPL_T_STRING = 258,        /* SMARTPL_T_STRING  */
    SMARTPL_T_NUM = 259,           /* SMARTPL_T_NUM  */
    SMARTPL_T_STRTAG = 260,        /* SMARTPL_T_STRTAG  */
    SMARTPL_T_INTTAG = 261,        /* SMARTPL_T_INTTAG  */
    SMARTPL_T_DATETAG = 262,       /* SMARTPL_T_DATETAG  */
    SMARTPL_T_GROUPTAG = 263,      /* SMARTPL_T_GROUPTAG  */
    SMARTPL_T_ENUMTAG = 264,       /* SMARTPL_T_ENUMTAG  */
    SMARTPL_T_ENUMTAG_DATAKIND = 265, /* SMARTPL_T_ENUMTAG_DATAKIND  */
    SMARTPL_T_ENUMTAG_MEDIAKIND = 266, /* SMARTPL_T_ENUMTAG_MEDIAKIND  */
    SMARTPL_T_ENUMTAG_SCANKIND = 267, /* SMARTPL_T_ENUMTAG_SCANKIND  */
    SMARTPL_T_FILE = 268,          /* SMARTPL_T_FILE  */
    SMARTPL_T_URL = 269,           /* SMARTPL_T_URL  */
    SMARTPL_T_SPOTIFY = 270,       /* SMARTPL_T_SPOTIFY  */
    SMARTPL_T_PIPE = 271,          /* SMARTPL_T_PIPE  */
    SMARTPL_T_RSS = 272,           /* SMARTPL_T_RSS  */
    SMARTPL_T_MUSIC = 273,         /* SMARTPL_T_MUSIC  */
    SMARTPL_T_MOVIE = 274,         /* SMARTPL_T_MOVIE  */
    SMARTPL_T_PODCAST = 275,       /* SMARTPL_T_PODCAST  */
    SMARTPL_T_AUDIOBOOK = 276,     /* SMARTPL_T_AUDIOBOOK  */
    SMARTPL_T_TVSHOW = 277,        /* SMARTPL_T_TVSHOW  */
    SMARTPL_T_DATEEXPR = 278,      /* SMARTPL_T_DATEEXPR  */
    SMARTPL_T_HAVING = 279,        /* SMARTPL_T_HAVING  */
    SMARTPL_T_ORDERBY = 280,       /* SMARTPL_T_ORDERBY  */
    SMARTPL_T_ORDER_ASC = 281,     /* SMARTPL_T_ORDER_ASC  */
    SMARTPL_T_ORDER_DESC = 282,    /* SMARTPL_T_ORDER_DESC  */
    SMARTPL_T_LIMIT = 283,         /* SMARTPL_T_LIMIT  */
    SMARTPL_T_RANDOM = 284,        /* SMARTPL_T_RANDOM  */
    SMARTPL_T_PARENS = 285,        /* SMARTPL_T_PARENS  */
    SMARTPL_T_OR = 286,            /* SMARTPL_T_OR  */
    SMARTPL_T_AND = 287,           /* SMARTPL_T_AND  */
    SMARTPL_T_NOT = 288,           /* SMARTPL_T_NOT  */
    SMARTPL_T_DAYS = 289,          /* SMARTPL_T_DAYS  */
    SMARTPL_T_WEEKS = 290,         /* SMARTPL_T_WEEKS  */
    SMARTPL_T_MONTHS = 291,        /* SMARTPL_T_MONTHS  */
    SMARTPL_T_YEARS = 292,         /* SMARTPL_T_YEARS  */
    SMARTPL_T_INTERVAL = 293,      /* SMARTPL_T_INTERVAL  */
    SMARTPL_T_DATE = 294,          /* SMARTPL_T_DATE  */
    SMARTPL_T_DATE_TODAY = 295,    /* SMARTPL_T_DATE_TODAY  */
    SMARTPL_T_DATE_YESTERDAY = 296, /* SMARTPL_T_DATE_YESTERDAY  */
    SMARTPL_T_DATE_THISWEEK = 297, /* SMARTPL_T_DATE_THISWEEK  */
    SMARTPL_T_DATE_LASTWEEK = 298, /* SMARTPL_T_DATE_LASTWEEK  */
    SMARTPL_T_DATE_LASTMONTH = 299, /* SMARTPL_T_DATE_LASTMONTH  */
    SMARTPL_T_DATE_LASTYEAR = 300, /* SMARTPL_T_DATE_LASTYEAR  */
    SMARTPL_T_IS = 301,            /* SMARTPL_T_IS  */
    SMARTPL_T_INCLUDES = 302,      /* SMARTPL_T_INCLUDES  */
    SMARTPL_T_STARTSWITH = 303,    /* SMARTPL_T_STARTSWITH  */
    SMARTPL_T_ENDSWITH = 304,      /* SMARTPL_T_ENDSWITH  */
    SMARTPL_T_EQUAL = 305,         /* SMARTPL_T_EQUAL  */
    SMARTPL_T_LESS = 306,          /* SMARTPL_T_LESS  */
    SMARTPL_T_LESSEQUAL = 307,     /* SMARTPL_T_LESSEQUAL  */
    SMARTPL_T_GREATER = 308,       /* SMARTPL_T_GREATER  */
    SMARTPL_T_GREATEREQUAL = 309,  /* SMARTPL_T_GREATEREQUAL  */
    SMARTPL_T_BEFORE = 310,        /* SMARTPL_T_BEFORE  */
    SMARTPL_T_AFTER = 311,         /* SMARTPL_T_AFTER  */
    SMARTPL_T_AGO = 312            /* SMARTPL_T_AGO  */
  };
  typedef enum smartpl_tokentype smartpl_token_kind_t;
#endif

/* Value type.  */
#if ! defined SMARTPL_STYPE && ! defined SMARTPL_STYPE_IS_DECLARED
union SMARTPL_STYPE
{
#line 461 "parsers/smartpl_parser.y"

  unsigned int ival;
  char *str;
  struct ast *ast;

#line 157 "parsers/smartpl_parser.h"

};
typedef union SMARTPL_STYPE SMARTPL_STYPE;
# define SMARTPL_STYPE_IS_TRIVIAL 1
# define SMARTPL_STYPE_IS_DECLARED 1
#endif




int smartpl_parse (struct smartpl_result *result, void *scanner);

/* "%code provides" blocks.  */
#line 42 "parsers/smartpl_parser.y"

/* Convenience functions for caller to use instead of interfacing with lexer and
   parser directly */
int smartpl_lex_cb(char *input, void (*cb)(int, const char *));
int smartpl_lex_parse(struct smartpl_result *result, const char *input);

#line 178 "parsers/smartpl_parser.h"

#endif /* !YY_SMARTPL_PARSERS_SMARTPL_PARSER_H_INCLUDED  */
